https://gitlab.gnome.org/GNOME/gnome-desktop/-/merge_requests/139

From 94b253000f081423a3c813d340ed486fc170768d Mon Sep 17 00:00:00 2001
From: Mart Raudsepp <leio@gentoo.org>
Date: Wed, 18 Sep 2019 22:28:21 +0300
Subject: [PATCH 2/2] meson: Add optionality for introspection

---
 libgnome-desktop/meson.build | 48 +++++++++++++++++++-----------------
 meson_options.txt            |  4 +++
 2 files changed, 30 insertions(+), 22 deletions(-)

diff --git a/libgnome-desktop/meson.build b/libgnome-desktop/meson.build
index a0fb11f8..375cf57c 100644
--- a/libgnome-desktop/meson.build
+++ b/libgnome-desktop/meson.build
@@ -125,17 +125,19 @@ if get_option('build_gtk4')
     ],
   )
 
-  libgnome_desktop_base_gir = gnome.generate_gir(libgnome_desktop_base,
-    sources: [libgnome_desktop_base_headers, libgnome_desktop_base_sources],
-    export_packages: 'gnome-desktop-4',
-    namespace: 'GnomeDesktop',
-    nsversion: '4.0',
-    includes: ['GObject-2.0', 'Gio-2.0', 'GDesktopEnums-3.0', 'GdkPixbuf-2.0'],
-    extra_args: ['-DGNOME_DESKTOP_USE_UNSTABLE_API', '--quiet', '--warn-all'],
-    identifier_prefix: 'Gnome',
-    symbol_prefix: 'gnome',
-    install: true,
-  )
+  if get_option('introspection')
+    libgnome_desktop_base_gir = gnome.generate_gir(libgnome_desktop_base,
+      sources: [libgnome_desktop_base_headers, libgnome_desktop_base_sources],
+      export_packages: 'gnome-desktop-4',
+      namespace: 'GnomeDesktop',
+      nsversion: '4.0',
+      includes: ['GObject-2.0', 'Gio-2.0', 'GDesktopEnums-3.0', 'GdkPixbuf-2.0'],
+      extra_args: ['-DGNOME_DESKTOP_USE_UNSTABLE_API', '--quiet', '--warn-all'],
+      identifier_prefix: 'Gnome',
+      symbol_prefix: 'gnome',
+      install: true,
+    )
+  endif
 
   pkg.generate(
     libgnome_desktop_base,
@@ -255,17 +257,19 @@ if get_option('legacy_library')
     ],
   )
 
-  gnome.generate_gir(libgnome_desktop,
-    sources: introspection_sources + libgnome_desktop_headers,
-    export_packages: 'gnome-desktop-3.0',
-    namespace: 'GnomeDesktop',
-    nsversion: '3.0',
-    includes: ['GObject-2.0', 'Gtk-3.0', 'GDesktopEnums-3.0'],
-    extra_args: ['-DGNOME_DESKTOP_USE_UNSTABLE_API', '--quiet', '--warn-all'],
-    identifier_prefix: 'Gnome',
-    symbol_prefix: 'gnome',
-    install: true
-  )
+  if get_option('introspection')
+    gnome.generate_gir(libgnome_desktop,
+      sources: introspection_sources + libgnome_desktop_headers,
+      export_packages: 'gnome-desktop-3.0',
+      namespace: 'GnomeDesktop',
+      nsversion: '3.0',
+      includes: ['GObject-2.0', 'Gtk-3.0', 'GDesktopEnums-3.0'],
+      extra_args: ['-DGNOME_DESKTOP_USE_UNSTABLE_API', '--quiet', '--warn-all'],
+      identifier_prefix: 'Gnome',
+      symbol_prefix: 'gnome',
+      install: true
+    )
+  endif
 
   pkg.generate(
     libraries: libgnome_desktop,
diff --git a/meson_options.txt b/meson_options.txt
index e17e7330..c4db6eaf 100644
--- a/meson_options.txt
+++ b/meson_options.txt
@@ -17,6 +17,10 @@ option('debug_tools',
   type: 'boolean', value: true, description: 'Build debug tools'
 )
 
+option('introspection',
+  type: 'boolean', value: true, description: 'Whether to build introspection files'
+)
+
 option('udev',
   type: 'feature', description: 'Udev support'
 )
-- 
2.34.1

